## GTypeModule GTypeModule — Type loading modules |

## Functions

gboolean | g_type_module_use ()
void | g_type_module_unuse ()
void | g_type_module_set_name ()
GType | g_type_module_register_type ()
void | g_type_module_add_interface ()
GType | g_type_module_register_enum ()
GType | g_type_module_register_flags ()
#define | G_DEFINE_DYNAMIC_TYPE()
#define | G_DEFINE_DYNAMIC_TYPE_EXTENDED()
#define | G_IMPLEMENT_INTERFACE_DYNAMIC()
#define | G_ADD_PRIVATE_DYNAMIC()

## Types and Values

struct | GTypeModule
struct | GTypeModuleClass

## Object Hierarchy

        GObject
        ╰── GTypeModule

## Implemented Interfaces

GTypeModule implements GTypePlugin.

## Includes

    #include <glib-object.h>

## Description

GTypeModule provides a simple implementation of the GTypePlugin interface.

The model of GTypeModule is a dynamically loaded module which implements some number of types and interface implementations.

When the module is loaded, it registers its types and interfaces using `g_type_module_register_type()` and `g_type_module_add_interface()`. As long as any instances of these types and interface implementations are in use, the module is kept loaded. When the types and interfaces are gone, the module may be unloaded. If the types and interfaces become used again, the module will be reloaded. Note that the last reference cannot be released from within the module code, since that would lead to the caller's code being unloaded before `g_object_unref()` returns to it.

Keeping track of whether the module should be loaded or not is done by using a use count - it starts at zero, and whenever it is greater than zero, the module is loaded. The use count is maintained internally by the type system, but also can be explicitly controlled by `g_type_module_use()` and `g_type_module_unuse()`. Typically, when loading a module for the first type, `g_type_module_use()` will be used to load it so that it can initialize its types. At some later point, when the module no longer needs to be loaded except for the type implementations it contains, `g_type_module_unuse()` is called.

GTypeModule does not actually provide any implementation of module loading and unloading. To create a particular module type you must derive from GTypeModule and implement the load and unload functions in GTypeModuleClass.

## Functions

### g_type_module_use ()

    gboolean
    g_type_module_use (GTypeModule *module);

Increases the use count of a GTypeModule by one. If the use count was zero before, the plugin will be loaded. If loading the plugin fails, the use count is reset to its prior value.

#### Parameters

module | a GTypeModule |

#### Returns

`FALSE` if the plugin needed to be loaded and loading the plugin failed.

### g_type_module_unuse ()

    void
    g_type_module_unuse (GTypeModule *module);

Decreases the use count of a GTypeModule by one. If the result is zero, the module will be unloaded. (However, the GTypeModule will not be freed, and types associated with the GTypeModule are not unregistered. Once a GTypeModule is initialized, it must exist forever.)

#### Parameters

module | a GTypeModule |

### g_type_module_set_name ()

    void
    g_type_module_set_name (GTypeModule *module,
                            const gchar *name);

Sets the name for a GTypeModule

#### Parameters

module | a GTypeModule. |
name | a human-readable name to use in error messages. |

### g_type_module_register_type ()

    GType
    g_type_module_register_type (GTypeModule *module,
                                 GType parent_type,
                                 const gchar *type_name,
                                 const GTypeInfo *type_info,
                                 GTypeFlags flags);

Looks up or registers a type that is implemented with a particular type plugin. If a type with name `type_name` was previously registered, the GType identifier for the type is returned, otherwise the type is newly registered, and the resulting GType identifier returned.

When reregistering a type (typically because a module is unloaded then reloaded, and reinitialized), `module` and `parent_type` must be the same as they were previously.

As long as any instances of the type exist, the type plugin will not be unloaded.

Since 2.56 if `module` is `NULL` this will call `g_type_register_static()` instead. This can be used when making a static build of the module.

#### Parameters

module | a GTypeModule. | [nullable]
parent_type | the type for the parent class |
type_name | name for the type |
type_info | type information structure |
flags | flags field providing details about the type |

#### Returns

the new or existing type ID

### g_type_module_add_interface ()

    void
    g_type_module_add_interface (GTypeModule *module,
                                 GType instance_type,
                                 GType interface_type,
                                 const GInterfaceInfo *interface_info);

Registers an additional interface for a type, whose interface lives in the given type plugin. If the interface was already registered for the type in this plugin, nothing will be done.

As long as any instances of the type exist, the type plugin will not be unloaded.

Since 2.56 if `module` is `NULL` this will call `g_type_add_interface_static()` instead. This can be used when making a static build of the module.

#### Parameters

module | a GTypeModule. | [nullable]
instance_type | type to which to add the interface. |
interface_type | interface type to add |
interface_info | type information structure |

### g_type_module_register_enum ()

    GType
    g_type_module_register_enum (GTypeModule *module,
                                 const gchar *name,
                                 const GEnumValue *const_static_values);

Looks up or registers an enumeration that is implemented with a particular type plugin. If a type with name `type_name` was previously registered, the GType identifier for the type is returned, otherwise the type is newly registered, and the resulting GType identifier returned.

As long as any instances of the type exist, the type plugin will not be unloaded.

Since 2.56 if `module` is `NULL` this will call `g_type_register_static()` instead. This can be used when making a static build of the module.

#### Parameters

module | a GTypeModule. | [nullable]
name | name for the type |
const_static_values | an array of GEnumValue structs for the possible enumeration values. The array is terminated by a struct with all members being 0. |

#### Returns

the new or existing type ID

Since: 2.6

### g_type_module_register_flags ()

    GType
    g_type_module_register_flags (GTypeModule *module,
                                  const gchar *name,
                                  const GFlagsValue *const_static_values);

Looks up or registers a flags type that is implemented with a particular type plugin. If a type with name `type_name` was previously registered, the GType identifier for the type is returned, otherwise the type is newly registered, and the resulting GType identifier returned.

As long as any instances of the type exist, the type plugin will not be unloaded.

Since 2.56 if `module` is `NULL` this will call `g_type_register_static()` instead. This can be used when making a static build of the module.

#### Parameters

module | a GTypeModule. | [nullable]
name | name for the type |
const_static_values | an array of GFlagsValue structs for the possible flags values. The array is terminated by a struct with all members being 0. |

#### Returns

the new or existing type ID

Since: 2.6

### G_DEFINE_DYNAMIC_TYPE()

    #define G_DEFINE_DYNAMIC_TYPE(TN, t_n, T_P)          G_DEFINE_DYNAMIC_TYPE_EXTENDED (TN, t_n, T_P, 0, {})

A convenience macro for dynamic type implementations, which declares a class initialization function, an instance initialization function (see GTypeInfo for information about these) and a static variable named `t_n`_parent_class pointing to the parent class.

Furthermore, it defines a `*_get_type()` and a static `*_register_type()` functions for use in your ``module_init()``.

See `G_DEFINE_DYNAMIC_TYPE_EXTENDED()` for an example.

#### Parameters

TN | The name of the new type, in Camel case. |
t_n | The name of the new type, in lowercase, with words separated by '_'. |
T_P | The GType of the parent type. |

Since: 2.14

### G_DEFINE_DYNAMIC_TYPE_EXTENDED()

    #define             G_DEFINE_DYNAMIC_TYPE_EXTENDED(TypeName, type_name, TYPE_PARENT, flags, CODE)

A more general version of `G_DEFINE_DYNAMIC_TYPE()` which allows to specify GTypeFlags and custom code.

    1
    2
    3
    4
    5
    6
    G_DEFINE_DYNAMIC_TYPE_EXTENDED (GtkGadget,
                                    gtk_gadget,
                                    GTK_TYPE_THING,
                                    0,
                                    G_IMPLEMENT_INTERFACE_DYNAMIC (TYPE_GIZMO,
                                                                   gtk_gadget_gizmo_init));

expands to

    1
    2
    3
    4
    5
    6
    7
    8
    9
    10
    11
    12
    13
    14
    15
    16
    17
    18
    19
    20
    21
    22
    23
    24
    25
    26
    27
    28
    29
    30
    31
    32
    33
    34
    35
    36
    37
    38
    39
    40
    41
    42
    43
    44
    45
    46
    static void     gtk_gadget_init              (GtkGadget      *self);
    static void     gtk_gadget_class_init        (GtkGadgetClass *klass);
    static void     gtk_gadget_class_finalize    (GtkGadgetClass *klass);

    static gpointer gtk_gadget_parent_class = NULL;
    static GType    gtk_gadget_type_id = 0;

    static void     gtk_gadget_class_intern_init (gpointer klass)
    {
      gtk_gadget_parent_class = g_type_class_peek_parent (klass);
      gtk_gadget_class_init ((GtkGadgetClass*) klass);
    }

    GType
    gtk_gadget_get_type (void)
    {
      return gtk_gadget_type_id;
    }

    static void
    gtk_gadget_register_type (GTypeModule *type_module)
    {
      const GTypeInfo g_define_type_info = {
        sizeof (GtkGadgetClass),
        (GBaseInitFunc) NULL,
        (GBaseFinalizeFunc) NULL,
        (GClassInitFunc) gtk_gadget_class_intern_init,
        (GClassFinalizeFunc) gtk_gadget_class_finalize,
        NULL,   // class_data
        sizeof (GtkGadget),
        0,      // n_preallocs
        (GInstanceInitFunc) gtk_gadget_init,
        NULL    // value_table
      };
      gtk_gadget_type_id = g_type_module_register_type (type_module,
                                                        GTK_TYPE_THING,
                                                        "GtkGadget",
                                                        &g_define_type_info,
                                                        (GTypeFlags) flags);
      {
        const GInterfaceInfo g_implement_interface_info = {
          (GInterfaceInitFunc) gtk_gadget_gizmo_init
        };
        g_type_module_add_interface (type_module, g_define_type_id, TYPE_GIZMO, &g_implement_interface_info);
      }
    }

#### Parameters

TypeName | The name of the new type, in Camel case. |
type_name | The name of the new type, in lowercase, with words separated by '_'. |
TYPE_PARENT | The GType of the parent type. |
flags | GTypeFlags to pass to `g_type_module_register_type()` |
CODE | Custom code that gets inserted in the *_get_type() function. |

Since: 2.14

### G_IMPLEMENT_INTERFACE_DYNAMIC()

    #define             G_IMPLEMENT_INTERFACE_DYNAMIC(TYPE_IFACE, iface_init)

A convenience macro to ease interface addition in the `_C_` section of `G_DEFINE_DYNAMIC_TYPE_EXTENDED()`.

See `G_DEFINE_DYNAMIC_TYPE_EXTENDED()` for an example.

Note that this macro can only be used together with the G_DEFINE_DYNAMIC_TYPE_EXTENDED macros, since it depends on variable names from that macro.

#### Parameters

TYPE_IFACE | The GType of the interface to add |
iface_init | The interface init function |

Since: 2.24

### G_ADD_PRIVATE_DYNAMIC()

    #define             G_ADD_PRIVATE_DYNAMIC(TypeName)

A convenience macro to ease adding private data to instances of a new dynamic type in the `_C_` section of `G_DEFINE_DYNAMIC_TYPE_EXTENDED()`.

See `G_ADD_PRIVATE()` for details, it is similar but for static types.

Note that this macro can only be used together with the G_DEFINE_DYNAMIC_TYPE_EXTENDED macros, since it depends on variable names from that macro.

#### Parameters

TypeName | the name of the type in CamelCase |

Since: 2.38

## Types and Values

### struct GTypeModule

    struct GTypeModule {
      gchar *name;
    };

The members of the GTypeModule structure should not be accessed directly, except for the `name` field.

#### Members

gchar *`name`; | the name of the module |

### struct GTypeModuleClass

    struct GTypeModuleClass {
      GObjectClass parent_class;

      gboolean (* load)   (GTypeModule *module);
      void     (* unload) (GTypeModule *module);
    };

In order to implement dynamic loading of types based on GTypeModule, the `load` and `unload` functions in GTypeModuleClass must be implemented.

#### Members

`load` () | loads the module and registers one or more types using `g_type_module_register_type()`. |
`unload` () | unloads the module |

## See Also

GTypePlugin, GModule